Bugzilla (bugzilla.redhat.com) will be under maintenance for infrastructure upgrades and will not be unavailable on July 31st between 12:30 AM - 05:30 AM UTC. We appreciate your understanding and patience. You can follow status.redhat.com for details.
Bug 1651871 (CVE-2018-19115) - CVE-2018-19115 keepalived: Heap-based buffer overflow when parsing HTTP status codes allows for denial of service or possibly arbitrary code execution
Summary: CVE-2018-19115 keepalived: Heap-based buffer overflow when parsing HTTP statu...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2018-19115
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1651873 1652399 1652693 1652694 1719353 1719471
Blocks: 1651865
TreeView+ depends on / blocked
 
Reported: 2018-11-21 05:47 UTC by Sam Fowler
Modified: 2021-02-16 22:45 UTC (History)
9 users (show)

Fixed In Version: keepalived 2.0.9
Doc Type: If docs needed, set a value
Doc Text:
Heap-based buffer overflow vulnerability in extract_status_code() function in lib/html.c that parses HTTP status code returned from web server allows malicious web server or man-in-the-middle attacker pretending to be a web server to cause either a denial of service or potentially execute arbitrary code on keepalived load balancer.
Clone Of:
Environment:
Last Closed: 2019-06-10 10:42:54 UTC


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2019:0022 0 None None None 2019-01-03 21:37:47 UTC
Red Hat Product Errata RHSA-2019:1792 0 None None None 2019-07-16 13:45:48 UTC
Red Hat Product Errata RHSA-2019:1945 0 None None None 2019-07-30 09:08:43 UTC

Description Sam Fowler 2018-11-21 05:47:03 UTC
keepalived before version 2.0.9 has a heap-based buffer overflow when parsing HTTP status codes resulting in DoS or possibly unspecified other impact, because extract_status_code in lib/html.c has no validation of the status code and instead writes an unlimited amount of data to the heap.


Upstream Patch:

https://github.com/acassen/keepalived/pull/961/commits/f28015671a4b04785859d1b4b1327b367b6a10e9


Reference:

https://bugzilla.suse.com/show_bug.cgi?id=1015141

Comment 1 Sam Fowler 2018-11-21 05:47:32 UTC
Created keepalived tracking bugs for this issue:

Affects: fedora-all [bug 1651873]

Comment 7 Adam Mariš 2018-11-29 14:25:59 UTC
Statement:

This issue affects the versions of keepalived as shipped with Red Hat Enterprise Linux 6 and 7.

Red Hat Enterprise Linux 6 is now in Maintenance Support 2 Phase of the support and maintenance life cycle. This has been rated as having a security impact of Important, and is not currently planned to be addressed in future updates. For additional information, refer to the Red Hat Enterprise Linux Life Cycle: https://access.redhat.com/support/policy/updates/errata/.

Comment 8 Tomas Hoger 2019-01-03 19:26:15 UTC
Upstream bug report:

https://github.com/acassen/keepalived/issues/960

Comment 9 errata-xmlrpc 2019-01-03 21:37:46 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2019:0022 https://access.redhat.com/errata/RHSA-2019:0022

Comment 12 errata-xmlrpc 2019-07-16 13:45:47 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.5 Extended Update Support

Via RHSA-2019:1792 https://access.redhat.com/errata/RHSA-2019:1792

Comment 13 errata-xmlrpc 2019-07-30 09:08:42 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7.4 Extended Update Support

Via RHSA-2019:1945 https://access.redhat.com/errata/RHSA-2019:1945


Note You need to log in before you can comment on or make changes to this bug.